## plasma-desktop 5.27.11

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(plasma-desktop)

set(PROJECT_VERSION "5.27.11")
set(PROJECT_VERSION_MAJOR 5)

set(QT_MIN_VERSION "5.15.2")
set(KF5_MIN_VERSION "5.102.0")
set(KDE_COMPILERSETTINGS_LEVEL "5.85")
set(ACCOUNTSQT_DEP_VERSION "1.13")

find_package(ECM ${KF5_MIN_VERSION} REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(ECMFindQmlModule)
include(ECMInstallIcons)
include(ECMMarkAsTest)
include(ECMMarkNonGuiExecutable)
include(ECMOptionalAddSubdirectory)
include(ECMQtDeclareLoggingCategory)
include(ECMSetupVersion)
include(ECMQtDeclareLoggingCategory)
include(FeatureSummary)
include(CheckIncludeFiles)
include(KDEClangFormat)
include(KDEGitCommitHooks)

find_package(Qt${QT_MAJOR_VERSION} ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS
    Quick
    QuickWidgets
    DBus
    Widgets
    Svg
    Concurrent
)
find_package(Qt${QT_MAJOR_VERSION} ${QT_MIN_VERSION} CONFIG OPTIONAL_COMPONENTS WaylandClient)
if (QT_MAJOR_VERSION EQUAL "5")
    find_package(Qt5 ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS X11Extras)

    find_package(QtWaylandScanner)
    set_package_properties(QtWaylandScanner PROPERTIES
        TYPE REQUIRED
        PURPOSE "Required for building KWin with Wayland support"
    )
endif()

find_package(KF5 ${KF5_MIN_VERSION} REQUIRED COMPONENTS
    Auth
    Crash
    Plasma
    PlasmaQuick
    DocTools
    I18n
    KCMUtils
    NewStuff
    NewStuffQuick
    KIO
    Notifications
    NotifyConfig
    Attica
    Runner
    GlobalAccel
    CoreAddons # KSharedDataCache required by KImageCache, KStringHandler required by FolderModel
    GuiAddons # KImageCache
    Declarative
    DBusAddons
    Activities
    ActivitiesStats
    Config
    WidgetsAddons
    Codecs
    Sonnet
    Package
)
if (QT_MAJOR_VERSION EQUAL "5")
    find_package(KF5 ${KF5_MIN_VERSION} REQUIRED COMPONENTS KDELibs4Support) # kcms/dateandtime
endif()

find_package(AccountsQt${QT_MAJOR_VERSION} ${ACCOUNTSQT_DEP_VERSION} CONFIG)

set_package_properties(AccountsQt${QT_MAJOR_VERSION} PROPERTIES
    DESCRIPTION "Accounts management library for Qt applications"
    URL "https://gitlab.com/accounts-sso/libaccounts-qt"
    PURPOSE "Required for building the OpenDesktop integration plugin"
    TYPE OPTIONAL
)

find_package(KAccounts 20.04)
set_package_properties(KAccounts PROPERTIES
    DESCRIPTION "Accounts management library for KDE applications"
    PURPOSE "Required for building the OpenDesktop integration plugin"
    TYPE OPTIONAL
)

find_package(PkgConfig REQUIRED)
pkg_check_modules(SignOnOAuth2 IMPORTED_TARGET signon-oauth2plugin)
set_package_properties(signon-oauth2plugin PROPERTIES
    DESCRIPTION "Plugin for SignOnQt${QT_MAJOR_VERSION} which handles OAuth and OAuth2 logins"
    URL "https://gitlab.com/accounts-sso/signon-plugin-oauth2"
    PURPOSE "Required for running the OpenDesktop integration plugin"
    TYPE RUNTIME
)

find_package(KF5Kirigami2 ${KF5_MIN_VERSION} CONFIG)
set_package_properties(KF5Kirigami2 PROPERTIES
    DESCRIPTION "A QtQuick based components set"
    PURPOSE "Required at runtime by many KCMs"
    TYPE RUNTIME
)

find_package(KF5QQC2DesktopStyle ${KF5_MIN_VERSION} CONFIG)
set_package_properties(KF5QQC2DesktopStyle PROPERTIES
    DESCRIPTION "QtQuickControls 2 style that uses QWidget's QStyle for painting"
    PURPOSE "Required at runtime by many KCMs"
    TYPE RUNTIME
)

find_package(WaylandProtocols 1.25)
set_package_properties(WaylandProtocols PROPERTIES
    TYPE REQUIRED
    PURPOSE "Collection of Wayland protocols that add functionality not available in the Wayland core protocol"
    URL "https://gitlab.freedesktop.org/wayland/wayland-protocols/"
)
find_package(Wayland 1.2)
set_package_properties(Wayland PROPERTIES
    TYPE REQUIRED
    PURPOSE "Required for building Tablet input KCM"
)

find_package(LibKWorkspace ${PROJECT_VERSION} CONFIG REQUIRED)
find_package(LibNotificationManager ${PROJECT_VERSION} CONFIG REQUIRED)
find_package(LibTaskManager ${PROJECT_VERSION} CONFIG REQUIRED)
find_package(LibColorCorrect ${PROJECT_VERSION} CONFIG REQUIRED)
find_package(KWinDBusInterface CONFIG REQUIRED)
find_package(ScreenSaverDBusInterface CONFIG REQUIRED)
find_package(KRunnerAppDBusInterface CONFIG REQUIRED)
find_package(KSMServerDBusInterface CONFIG REQUIRED)
find_package(KF5ItemModels CONFIG REQUIRED)
find_package(KSysGuard CONFIG REQUIRED)
find_package(KDED CONFIG REQUIRED)

find_package(KF5Baloo ${KF5_MIN_VERSION})
set_package_properties(KF5Baloo PROPERTIES
    DESCRIPTION "File Searching"
    PURPOSE "Needed to build the File Search KCM"
    TYPE RECOMMENDED
)

find_package(X11)
set_package_properties(X11 PROPERTIES
    DESCRIPTION "X11 libraries"
    URL "https://www.x.org"
    PURPOSE "Required for building the X11 based workspace"
    TYPE REQUIRED
)

if(X11_FOUND)
  set(HAVE_X11 1)
endif()

find_package(UDev)
set_package_properties(UDev PROPERTIES
    DESCRIPTION "API for enumerating and introspecting local devices (part of systemd)"
    URL "https://www.freedesktop.org/wiki/Software/systemd/"
    PURPOSE "Required for device discovery in keyboard daemon"
    TYPE OPTIONAL
)

find_package(XCB
    REQUIRED COMPONENTS
        XCB SHM IMAGE
    OPTIONAL_COMPONENTS
        XKB XINPUT ATOM RECORD
)

find_package(X11_XCB)
set_package_properties(X11_XCB PROPERTIES
    PURPOSE "Required for needed for touchpad KCM (X11 backend)"
    TYPE OPTIONAL
)

set_package_properties(XCB PROPERTIES TYPE REQUIRED)
add_feature_info("XCB-XKB" XCB_XKB_FOUND "Required for building kcm/keyboard")
add_feature_info("libxft" X11_Xft_FOUND "X FreeType interface library required for font installation")

pkg_check_modules(XORGLIBINPUT xorg-libinput IMPORTED_TARGET)
pkg_check_modules(EVDEV xorg-evdev>=2.8.99.1 IMPORTED_TARGET)
pkg_check_modules(XORGSERVER xorg-server IMPORTED_TARGET)

ecm_find_qmlmodule(org.kde.pipewire 0.1)

find_package(Synaptics)
set_package_properties(Synaptics PROPERTIES TYPE OPTIONAL)
add_feature_info("Synaptics" SYNAPTICS_FOUND "Synaptics libraries are needed for the synaptics touchpad KCM")

if(SYNAPTICS_FOUND)
    set(HAVE_SYNAPTICS 1)
endif()

if(XORGLIBINPUT_FOUND)
  set(HAVE_XORGLIBINPUT 1)
endif()

include(ConfigureChecks.cmake)

find_package(PackageKitQt${QT_MAJOR_VERSION})
set_package_properties(PackageKitQt${QT_MAJOR_VERSION} PROPERTIES
    DESCRIPTION "Software Manager integration"
    PURPOSE "Used in the KRunner plugin installer"
    TYPE OPTIONAL
)

if(PackageKitQt${QT_MAJOR_VERSION}_FOUND)
    set(HAVE_PACKAGEKIT TRUE)
endif()

find_package(GLIB2)
set_package_properties(GLIB2 PROPERTIES
    PURPOSE "Required for building kimpanel"
    TYPE OPTIONAL
)

# For kimpanel
pkg_check_modules(IBUS "ibus-1.0>=1.5.0" IMPORTED_TARGET)
pkg_check_modules(GOBJECT gobject-2.0 IMPORTED_TARGET)
pkg_check_modules(SCIM scim IMPORTED_TARGET)

ecm_setup_version(${PROJECT_VERSION} VARIABLE_PREFIX PLASMA VERSION_HEADER plasma_version.h)

include_directories("${CMAKE_CURRENT_BINARY_DIR}")

configure_file(config-workspace.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-workspace.h)
configure_file(config-X11.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-X11.h)

plasma_install_package(desktoppackage org.kde.plasma.desktop shells shell)

add_subdirectory(layout-templates)

add_subdirectory(doc)
add_subdirectory(runners)
add_subdirectory(containments)
add_subdirectory(toolboxes)
add_subdirectory(applets)
add_subdirectory(kcms)
add_subdirectory(knetattach)
if(KAccounts_FOUND AND AccountsQt${QT_MAJOR_VERSION}_FOUND)
    add_subdirectory(attica-kde)
endif()
add_subdirectory(imports/activitymanager/)
add_subdirectory(solid-device-automounter)
add_subdirectory(emojier)
if(X11_Xkb_FOUND AND XCB_XKB_FOUND)
    add_subdirectory(kaccess)
endif()
install(FILES org.kde.plasmashell.metainfo.xml DESTINATION ${KDE_INSTALL_METAINFODIR})

# add clang-format target for all our real source files
file(GLOB_RECURSE ALL_CLANG_FORMAT_SOURCE_FILES *.cpp *.h)
kde_clang_format(${ALL_CLANG_FORMAT_SOURCE_FILES})
kde_configure_git_pre_commit_hook(CHECKS CLANG_FORMAT)

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

find_package(XdgUserDir)
set_package_properties(XdgUserDir PROPERTIES
    DESCRIPTION "Xdg-user-dir script"
    PURPOSE "Used to translate default paths in KCM desktoppath"
    TYPE RUNTIME
)

ki18n_install(po)
kdoctools_install(po)

=== kcms/CMakeLists.txt ===
remove_definitions(-DQT_NO_CAST_FROM_ASCII -DQT_STRICT_ITERATORS -DQT_NO_CAST_FROM_BYTEARRAY -DQT_NO_KEYWORDS)

add_subdirectory(libkwindevices)

if(X11_Xkb_FOUND AND XCB_XKB_FOUND)
    add_subdirectory( keyboard )
endif()

if (EVDEV_FOUND AND XORGLIBINPUT_FOUND AND X11_Xi_FOUND)
    add_subdirectory( mouse )
endif()

add_subdirectory( access )
add_subdirectory( dateandtime )
add_subdirectory( ksplash )

add_subdirectory( landingpage )
add_subdirectory( keys )
add_subdirectory( ksmserver )

if (CMAKE_SYSTEM_NAME MATCHES Linux)
   # this one doesn't seem to be very portable, Alex
   add_subdirectory( joystick )
endif ()

add_subdirectory( desktoppaths )

add_subdirectory(activities)
add_subdirectory(recentFiles)
add_subdirectory(componentchooser)
add_subdirectory(kded)
add_subdirectory(runners)
add_subdirectory(spellchecking)
add_subdirectory(qtquicksettings)
add_subdirectory(tablet)
add_subdirectory(touchscreen)

add_subdirectory(workspaceoptions)
if (KF5Baloo_FOUND)
   add_subdirectory(baloo)
endif()
add_subdirectory(solid_actions)

if (X11_XCB_FOUND AND X11_Xi_FOUND AND XORGSERVER_FOUND)
    add_subdirectory(touchpad)
endif()

install(FILES migrationlib/kcm_rename_plasma_desktop.upd DESTINATION ${KDE_INSTALL_KCONFUPDATEDIR})
install(PROGRAMS migrationlib/kcm_rename_plasma_desktop.sh DESTINATION ${KDE_INSTALL_KCONFUPDATEDIR} )

=== applets/pager/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"plasma_applet_org.kde.plasma.pager\")
plasma_install_package(package org.kde.plasma.pager)

set(pager_SRCS
    plugin/pagermodel.cpp
    plugin/pagerplugin.cpp
    plugin/windowmodel.cpp)

add_library(pagerplugin SHARED ${pager_SRCS})

target_link_libraries(pagerplugin
                      KF5::KIOCore
                      KF5::WindowSystem
                      KF5::Plasma
                      KF5::Activities
                      PW::LibTaskManager
                      Qt::Core
                      Qt::DBus
                      Qt::Qml
                      Qt::Quick)

if (X11_FOUND)
    if (QT_MAJOR_VERSION EQUAL "5")
        target_link_libraries(pagerplugin Qt::X11Extras)
    else()
        target_link_libraries(pagerplugin Qt::GuiPrivate)
    endif()
endif()

install(TARGETS pagerplugin DESTINATION ${KDE_INSTALL_QMLDIR}/org/kde/plasma/private/pager)
install(FILES plugin/qmldir DESTINATION ${KDE_INSTALL_QMLDIR}/org/kde/plasma/private/pager)

=== doc/kcontrol/CMakeLists.txt ===
ecm_optional_add_subdirectory(clock)
ecm_optional_add_subdirectory(colors)
ecm_optional_add_subdirectory(joystick)
ecm_optional_add_subdirectory(kcmaccess)
ecm_optional_add_subdirectory(kcmactivities)
ecm_optional_add_subdirectory(kcmstyle)
ecm_optional_add_subdirectory(solid-actions)
ecm_optional_add_subdirectory(splashscreen)
ecm_optional_add_subdirectory(cookies)
ecm_optional_add_subdirectory(baloo)

ecm_optional_add_subdirectory(fonts)
ecm_optional_add_subdirectory(fontinst)
ecm_optional_add_subdirectory(keys)
ecm_optional_add_subdirectory(keyboard)
ecm_optional_add_subdirectory(mouse)
ecm_optional_add_subdirectory(paths)
ecm_optional_add_subdirectory(kcmsmserver)
ecm_optional_add_subdirectory(spellchecking)
ecm_optional_add_subdirectory(componentchooser)
ecm_optional_add_subdirectory(kded)
ecm_optional_add_subdirectory(solid-device-automounter)
ecm_optional_add_subdirectory(workspaceoptions)

=== imports/activitymanager/CMakeLists.txt ===
set (
   activityswitcher_imports_LIB_SRCS
   activityswitcherextensionplugin.cpp
   switcherbackend.cpp
   sortedactivitiesmodel.cpp
   )

add_library (activityswitcherextensionplugin SHARED ${activityswitcher_imports_LIB_SRCS})
add_definitions(-DTRANSLATION_DOMAIN=\"plasmaactivitymanager\")

target_link_libraries (
   activityswitcherextensionplugin

   Qt::Core
   Qt::Quick
   Qt::Qml
   Qt::Widgets

   KF5::I18n
   KF5::Activities
   KF5::ConfigCore
   KF5::CoreAddons
   KF5::GlobalAccel
   KF5::GuiAddons
   KF5::KIOCore
   KF5::KIOWidgets
   KF5::WindowSystem

   PW::LibTaskManager
   )

## install

install (TARGETS activityswitcherextensionplugin
         DESTINATION ${KDE_INSTALL_QMLDIR}/org/kde/plasma/activityswitcher)
install (FILES qmldir
         DESTINATION ${KDE_INSTALL_QMLDIR}/org/kde/plasma/activityswitcher)

=== kcms/baloo/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kcm_baloofile\")

set(kcm_file_SRCS
  kcm.cpp
  fileexcludefilters.cpp
  filteredfoldermodel.cpp
  baloodata.cpp
)

kcoreaddons_add_plugin(kcm_baloofile SOURCES ${kcm_file_SRCS} INSTALL_NAMESPACE "plasma/kcms/systemsettings")
kcmutils_generate_desktop_file(kcm_baloofile)

target_link_libraries(kcm_baloofile
  KF5::CoreAddons
  KF5::KCMUtils
  KF5::I18n
  KF5::Solid
  KF5::Baloo
  KF5::QuickAddons
  Qt::DBus
  Qt::Widgets
)

kpackage_install_package(package kcm_baloofile kcms)

=== kcms/componentchooser/CMakeLists.txt ===
# KI18N Translation Domain for this library
add_definitions(-DTRANSLATION_DOMAIN=\"kcm_componentchooser\")

set(componentchooser_SRCS
    kcm_componentchooser.cpp
    componentchooser.cpp
    componentchooserbrowser.cpp
    componentchooseremail.cpp
    componentchooserterminal.cpp
    componentchooserfilemanager.cpp
    componentchooserdata.cpp
    componentchoosergeo.cpp
    componentchoosertel.cpp
)

kconfig_add_kcfg_files(componentchooser_SRCS browser_settings.kcfgc GENERATE_MOC)
kconfig_add_kcfg_files(componentchooser_SRCS terminal_settings.kcfgc GENERATE_MOC)

kcoreaddons_add_plugin(kcm_componentchooser SOURCES ${componentchooser_SRCS} INSTALL_NAMESPACE "plasma/kcms/systemsettings")
kcmutils_generate_desktop_file(kcm_componentchooser)

target_link_libraries(kcm_componentchooser
    Qt::Core
    KF5::CoreAddons
    KF5::I18n
    KF5::QuickAddons
    KF5::Service
    KF5::KIOWidgets
    KF5::ConfigGui
    KF5::KCMUtils
)

kpackage_install_package(package kcm_componentchooser kcms)

=== kcms/dateandtime/CMakeLists.txt ===
# KI18N Translation Domain for this library
add_definitions(-DTRANSLATION_DOMAIN=\"kcmkclock\")
########### next target ###############

set(kcm_clock_PART_SRCS dtime.cpp main.cpp )

ki18n_wrap_ui(kcm_clock_PART_SRCS dateandtime.ui)

qt_add_dbus_interface(kcm_clock_PART_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/timedated1.xml timedated_interface)

if (QT_MAJOR_VERSION EQUAL "5" OR NOT PROJECT_VERSION_MAJOR EQUAL "5")
add_library(kcm_clock MODULE ${kcm_clock_PART_SRCS})
kcmutils_generate_desktop_file(kcm_clock)

target_link_libraries(kcm_clock
    Qt::DBus
    KF5::ItemViews
    KF5::AuthCore
    KF5::KCMUtils
    KF5::I18n
    KF5::KIOCore
    KF5::KIOWidgets
    KF5::Plasma
    KF5::KDELibs4Support
)

install(TARGETS kcm_clock  DESTINATION ${KDE_INSTALL_PLUGINDIR}/plasma/kcms/systemsettings_qwidgets )
else()
message(WARNING "TODO: kcm_clock not ported away from KDELibs4Support yet!")
endif()

########### next target ###############
#This is only needed when not using timedated and can be removed in future

add_executable(kcmdatetimehelper helper.cpp ${helper_mocs})
target_link_libraries(kcmdatetimehelper KF5::AuthCore KF5::ConfigCore)

install(TARGETS kcmdatetimehelper DESTINATION ${KAUTH_HELPER_INSTALL_DIR})
kauth_install_helper_files(kcmdatetimehelper org.kde.kcontrol.kcmclock root)

kauth_install_actions(org.kde.kcontrol.kcmclock kcmclock_actions.actions)

=== kcms/kded/CMakeLists.txt ===
# KI18N Translation Domain for this library
add_definitions(-DTRANSLATION_DOMAIN=\"kcm5_kded\")

set(kcm_kded_SRCS
    kcmkded.cpp
    modulesmodel.cpp
    filterproxymodel.cpp
    kdedconfigdata.cpp
)

qt_add_dbus_interface(kcm_kded_SRCS ${KDED_DBUS_INTERFACE} kded_interface)

ecm_qt_declare_logging_category(kcm_kded_SRCS HEADER debug.h
                                IDENTIFIER KCM_KDED
                                CATEGORY_NAME kcm_kded
                                DEFAULT_SEVERITY Info
                                DESCRIPTION "KCM for kded services"
                                EXPORT kcm_kded)

ecm_qt_install_logging_categories(
       EXPORT kcm_kded
       DESTINATION "${KDE_INSTALL_LOGGINGCATEGORIESDIR}"
)

kcoreaddons_add_plugin(kcm_kded SOURCES ${kcm_kded_SRCS} INSTALL_NAMESPACE "plasma/kcms/systemsettings")
kcmutils_generate_desktop_file(kcm_kded)

target_link_libraries(kcm_kded KF5::QuickAddons KF5::Service KF5::I18n KF5::KCMUtils Qt::DBus)

kpackage_install_package(package kcm5_kded kcms)

=== kcms/ksplash/CMakeLists.txt ===
# KI18N Translation Domain for this library
add_definitions(-DTRANSLATION_DOMAIN=\"kcm_splashscreen\")

set(kcm_splashscreen_SRCS
  kcm.cpp
)

kcmutils_generate_module_data(
    kcm_splashscreen_SRCS
    MODULE_DATA_HEADER splashscreendata.h
    MODULE_DATA_CLASS_NAME SplashScreenData
    SETTINGS_HEADERS splashscreensettings.h
    SETTINGS_CLASSES SplashScreenSettings
)

kconfig_add_kcfg_files(kcm_splashscreen_SRCS splashscreensettings.kcfgc GENERATE_MOC)

kcoreaddons_add_plugin(kcm_splashscreen SOURCES ${kcm_splashscreen_SRCS} INSTALL_NAMESPACE "plasma/kcms/systemsettings")
kcmutils_generate_desktop_file(kcm_splashscreen)

target_link_libraries(kcm_splashscreen
  KF5::KIOWidgets
  KF5::CoreAddons
  KF5::ConfigWidgets
  KF5::KCMUtils
  KF5::QuickAddons
  KF5::I18n
  KF5::Plasma
  KF5::PlasmaQuick
  KF5::NewStuff
  KF5::Package

  Qt::DBus
  Qt::Widgets
  Qt::QuickWidgets
)

#this desktop file is installed only for retrocompatibility with sycoca
install(FILES splashscreensettings.kcfg DESTINATION ${KDE_INSTALL_KCFGDIR})
install( FILES ksplash.knsrc DESTINATION  ${KDE_INSTALL_KNSRCDIR} )

kpackage_install_package(package kcm_splashscreen kcms)

=== kcms/recentFiles/CMakeLists.txt ===
# vim:set softtabstop=3 shiftwidth=3 tabstop=3 expandtab:
add_definitions(-DTRANSLATION_DOMAIN=\"kcm_recentFiles\")

find_package (Qt${QT_MAJOR_VERSION} REQUIRED NO_MODULE COMPONENTS Core Quick Sql Qml DBus)
find_package (KF5KCMUtils ${KF5_DEP_VERSION} CONFIG REQUIRED)
find_package (KF5Declarative ${KF5_DEP_VERSION} CONFIG REQUIRED)
find_package (KF5XmlGui ${KF5_DEP_VERSION} CONFIG REQUIRED)
find_package (KF5GlobalAccel ${KF5_DEP_VERSION} CONFIG REQUIRED)
find_package (KF5Activities ${KF5_DEP_VERSION} CONFIG REQUIRED)

set (KAMD_KCM_DATADIR
   ${KDE_INSTALL_DATADIR_KF5}/kcm_recentFiles/workspace/settings/
   )

if (NOT IS_ABSOLUTE "${KDE_INSTALL_DATADIR_KF5}")
   set (KAMD_KCM_DATADIR "${CMAKE_INSTALL_PREFIX}/${KAMD_KCM_DATADIR}")
endif ()

configure_file (recentFiles-kcm-features.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/recentFiles-kcm-features.h)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

set (KAMD_KCM_SRCS
   kcm_recentFiles.cpp

   BlacklistedApplicationsModel.cpp
   )

ki18n_wrap_ui (
   KAMD_KCM_SRCS
   ui/RecentFiles.ui
   )

qt_add_dbus_interface (
   KAMD_KCM_SRCS

   common/dbus/org.kde.ActivityManager.ResourceScoring.xml
   resourcescoring_interface
   )


kcmutils_generate_module_data(
    KAMD_KCM_SRCS
    MODULE_DATA_HEADER kactivitiesdata.h
    MODULE_DATA_CLASS_NAME KActivitiesData
    SETTINGS_HEADERS kactivitymanagerd_settings.h kactivitymanagerd_plugins_settings.h
    SETTINGS_CLASSES KActivityManagerdSettings KActivityManagerdPluginsSettings
)

kconfig_add_kcfg_files(KAMD_KCM_SRCS kactivitymanagerd_settings.kcfgc GENERATE_MOC)
kconfig_add_kcfg_files(KAMD_KCM_SRCS kactivitymanagerd_plugins_settings.kcfgc GENERATE_MOC)

add_library (kcm_recentFiles MODULE ${KAMD_KCM_SRCS})

kcmutils_generate_desktop_file(kcm_recentFiles)
target_link_libraries (kcm_recentFiles
   Qt::Quick
   Qt::QuickWidgets
   Qt::Core
   Qt::Sql
   Qt::Qml
   Qt::DBus
   KF5::KCMUtils
   KF5::I18n
   KF5::Service
   KF5::Declarative
   KF5::XmlGui
   KF5::Activities
   )

install (
   TARGETS kcm_recentFiles
   DESTINATION ${KDE_INSTALL_PLUGINDIR}/plasma/kcms/systemsettings_qwidgets
   )

install (
   DIRECTORY

   qml/recentFiles

   DESTINATION ${KAMD_KCM_DATADIR}/qml
   )

install(FILES kactivitymanagerd_settings.kcfg DESTINATION ${KDE_INSTALL_KCFGDIR})
install(FILES kactivitymanagerd_plugins_settings.kcfg DESTINATION ${KDE_INSTALL_KCFGDIR})

include(ECMQtDeclareLoggingCategory)
ecm_qt_declare_logging_category(kcm_recentFiles
    HEADER kcms-recentfiles-debug.h
    IDENTIFIER "LOG_KCMS_RECENTFILES"
    CATEGORY_NAME "org.kde.kcms.recentFiles"
)

=== kcms/solid_actions/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN="kcm_solid_actions")

add_subdirectory(device-actions)

########### next target ###############

set(kcm_solid_actions_srcs
    PredicateItem.cpp
    PredicateModel.cpp
    ActionItem.cpp
    ActionModel.cpp
    ActionEditor.cpp
    SolidActionData.cpp
    SolidActions.cpp )

set(solid_action_desktop_gen_srcs
    DesktopFileGenerator.cpp
    SolidActionData.cpp )

ki18n_wrap_ui(kcm_solid_actions_srcs
    SolidActions.ui
    AddAction.ui
    ActionEditor.ui )

add_library(kcm_solid_actions MODULE ${kcm_solid_actions_srcs})
kcmutils_generate_desktop_file(kcm_solid_actions)

add_executable(solid-action-desktop-gen ${solid_action_desktop_gen_srcs})

target_link_libraries(kcm_solid_actions KF5::KIOCore KF5::KIOWidgets KF5::Solid KF5::I18n KF5::IconThemes KF5::ConfigWidgets KF5::CoreAddons)
target_link_libraries(solid-action-desktop-gen KF5::Solid KF5::KIOCore KF5::I18n KF5::KIOWidgets)

########### install files ###############

install( TARGETS kcm_solid_actions DESTINATION ${KDE_INSTALL_PLUGINDIR}/plasma/kcms/systemsettings_qwidgets )
install( TARGETS solid-action-desktop-gen ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} )
install( FILES solid-action-template.desktop DESTINATION ${KDE_INSTALL_DATADIR}/kcmsolidactions )
install( FILES solid-device-type.desktop DESTINATION ${KDE_INSTALL_KSERVICETYPESDIR} )

=== debian/changelog ===
plasma-desktop (4:5.27.11-0ubuntu2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 00:13:06 +0000

plasma-desktop (4:5.27.11-0ubuntu1) noble; urgency=medium

  [ Scarlett Moore ]
  * New upstream release (5.27.11)

  [ José Manuel Santamaría Lema ]
  * Replace obsolete pkg-config build depend with pkgconf

 -- Scarlett Moore <sgmoore@debian.org>  Sun, 17 Mar 2024 07:23:41 +0000

plasma-desktop (4:5.27.10-1ubuntu4) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 06:25:25 +0000

plasma-desktop (4:5.27.10-1ubuntu3) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 11 Mar 2024 23:28:55 +0000

plasma-desktop (4:5.27.10-1ubuntu2) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 06:40:41 +0000

plasma-desktop (4:5.27.10-1ubuntu1) noble; urgency=low

  [ Ubuntu Merge-o-Matic ]
  * Merge from Debian unstable. Remaining changes:
    - Kubuntu Vcs and maintainer fields.
    - Kubuntu kickoff favourites.patch
    - Runtime depend on qml-module-org-kde-kirigami2, xdg-user-dirs,
      and qml-module-org-kde-pipewire.
    - Do not recommend plasma-workspace-wayland or plasma-welcome.

  [ Scarlett Moore ]
  * Release to archive.

 -- Scarlett Moore <sgmoore@debian.org>  Wed, 21 Feb 2024 04:03:53 -0700

plasma-desktop (4:5.27.10-1) unstable; urgency=medium

  [ Patrick Franz ]
  * New upstream release (5.27.10).
  * Update build-deps and deps with the info from cmake.

 -- Patrick Franz <deltaone@debian.org>  Thu, 11 Jan 2024 23:28:12 +0100

plasma-desktop (4:5.27.10-0ubuntu1) noble; urgency=medium

  * New upstream release (5.27.10)

 -- José Manuel Santamaría Lema <panfaust@gmail.com>  Mon, 11 Dec 2023 11:22:20 +0000

plasma-desktop (4:5.27.9-1) unstable; urgency=medium

  [ Patrick Franz ]
  * New upstream release (5.27.9).
  * Update build-deps and deps with the info from cmake.
  * Remove patches that have been applied upstream.

 -- Patrick Franz <deltaone@debian.org>  Fri, 27 Oct 2023 21:55:16 +0200

plasma-desktop (4:5.27.9-0ubuntu1) noble; urgency=medium

  * New upstream release (5.27.9)

 -- Rik Mills <rikmills@kde.org>  Thu, 26 Oct 2023 12:19:33 +0100

plasma-desktop (4:5.27.8-2) unstable; urgency=medium

  [ Patrick Franz ]
  * Fix versions of plasma-firewall and plasma-welcome in list of
    recommended packages (Closes: #1041450).
  * Add patch to fix plasmashell crashes when dropping a folder with
    many files onto the desktop.

 -- Patrick Franz <deltaone@debian.org>  Sat, 07 Oct 2023 14:21:10 +0200

plasma-desktop (4:5.27.8-1) unstable; urgency=medium

  [ Patrick Franz ]
  * New upstream release (5.27.8).
  * Update build-deps and deps with the info from cmake.

 -- Patrick Franz <deltaone@debian.org>  Wed, 13 Sep 2023 22:31:15 +0200

=== debian/control ===
Source: plasma-desktop
Section: kde
Priority: optional
Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
           Norbert Preining <norbert@preining.info>,
           Patrick Franz <deltaone@debian.org>,
           Scarlett Moore <sgmoore@kde.org>,
Build-Depends: baloo-kf5-dev (>= 5.102.0~),
               cmake (>= 3.16~),
               debhelper-compat (= 13),
               extra-cmake-modules (>= 5.102.0~),
               gettext,
               intltool,
               kded5-dev (>= 5.102.0~),
               kinit-dev (>= 5.102.0~),
               kirigami2-dev (>= 5.102.0~),
               kscreenlocker-dev (>= 5.27.11~),
               kuserfeedback-dev,
               kwin-dev (>= 4:5.27.11~),
               libaccounts-qt5-dev (>= 1.13~),
               libboost-dev,
               libfontconfig-dev,
               libfreetype-dev,
               libglib2.0-dev,
               libibus-1.0-dev (>= 1.5.0~),
               libkaccounts-dev (>= 4:20.04~),
               libkf5activities-dev (>= 5.102.0~),
               libkf5activitiesstats-dev (>= 5.102.0~),
               libkf5attica-dev (>= 5.102.0~),
               libkf5auth-dev (>= 5.102.0~),
               libkf5codecs-dev (>= 5.102.0~),
               libkf5config-dev (>= 5.102.0~),
               libkf5coreaddons-dev (>= 5.102.0~),
               libkf5crash-dev (>= 5.102.0~),
               libkf5dbusaddons-dev (>= 5.102.0~),
               libkf5declarative-dev (>= 5.102.0~),
               libkf5doctools-dev (>= 5.102.0~),
               libkf5globalaccel-dev (>= 5.102.0~),
               libkf5guiaddons-dev (>= 5.102.0~),
               libkf5i18n-dev (>= 5.102.0~),
               libkf5itemmodels-dev (>= 5.102.0~),
               libkf5kcmutils-dev (>= 5.102.0~),
               libkf5kdelibs4support-dev (>= 5.102.0~),
               libkf5kio-dev (>= 5.102.0~),
               libkf5newstuff-dev (>= 5.102.0~),
               libkf5notifications-dev (>= 5.102.0~),
               libkf5notifyconfig-dev (>= 5.102.0~),
               libkf5package-dev (>= 5.102.0~),
               libkf5plasma-dev (>= 5.102.0~),
               libkf5runner-dev (>= 5.102.0~),
               libkf5sonnet-dev (>= 5.102.0~),
               libkf5sysguard-dev (>= 4:5.27.11~),
               libkf5widgetsaddons-dev (>= 5.102.0~),
               libkf5windowsystem-dev (>= 5.102.0~),
               libkf5xmlgui-dev (>= 5.102.0~),
               libpackagekitqt5-dev,
               libphonon4qt5-dev (>= 4.6.60),
               libphonon4qt5experimental-dev,
               libqt5svg5-dev (>= 5.15.2~),
               libqt5waylandclient5-dev (>= 5.15.2~),
               libqt5x11extras5-dev (>= 5.15.2~),
               libscim-dev,
               libudev-dev,
               libx11-dev,
               libx11-xcb-dev,
               libxcb-image0-dev,
               libxcb-keysyms1-dev,
               libxcb-record0-dev,
               libxcb-shm0-dev,
               libxcb-util-dev,
               libxcb-xinput-dev,
               libxcb-xkb-dev,
               libxcb1-dev,
               libxcursor-dev,
               libxft-dev,
               libxi-dev,
               libxkbfile-dev,
               pkg-kde-tools (>= 0.15.18~),
               pkgconf,
               plasma-workspace-dev (>= 4:5.27.11~),
               qtbase5-dev (>= 5.15.2~),
               qtbase5-private-dev (>= 5.15.2~),
               qtdeclarative5-dev (>= 5.15.2~),
               qtwayland5-dev-tools,
               xserver-xorg-dev,
               xserver-xorg-input-evdev-dev,
               xserver-xorg-input-libinput-dev,
               xserver-xorg-input-synaptics-dev,
Standards-Version: 4.6.2
Homepage: https://invent.kde.org/plasma/plasma-desktop
Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/plasma-desktop
Vcs-Git: https://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/plasma-desktop
Rules-Requires-Root: no

Package: plasma-desktop
Architecture: any
Depends: accountsservice,
         breeze (>= 4:5.27.10~),
         kactivitymanagerd (>= 5.27.10~),
         kde-cli-tools (>= 4:5.27.10~),
         kded5,
         kio,
         layer-shell-qt (>= 5.27.10~),
         oxygen-sounds (>= 4:5.27.10~),
         plasma-desktop-data (= ${source:Version}),
         plasma-framework,
         plasma-integration (>= 5.27.10~),
         plasma-workspace (>= 4:5.27.10~),
         polkit-kde-agent-1 (>= 4:5.27.10~),
         qml-module-org-kde-draganddrop,
         qml-module-org-kde-kcoreaddons,
         qml-module-org-kde-kirigami2 (>= 5.54.0~),
         qml-module-org-kde-kquickcontrols,
         qml-module-org-kde-kquickcontrolsaddons,
         qml-module-org-kde-kwindowsystem,
         qml-module-org-kde-pipewire,
         qml-module-org-kde-qqc2desktopstyle (>= 5.58.0~),
         qml-module-org-kde-solid,
         qml-module-qt-labs-folderlistmodel,
         qml-module-qt-labs-settings,
         xdg-user-dirs,
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: bluedevil (>= 4:5.27.10~),
            breeze-gtk-theme (>= 5.27.10~),
            fonts-hack,
            fonts-noto-cjk,
            fonts-noto-hinted,
            fonts-noto-mono,
            fonts-noto-unhinted,
            ibus-data,
            kde-config-gtk-style (>= 4:5.27.10~),
            kde-config-screenlocker (>= 5.27.10~),
            kde-config-sddm (>= 4:5.27.10~),
            kde-style-oxygen-qt5 (>= 4:5.27.10~),
            kgamma5 (>= 5.27.10~),
            khelpcenter,
            khotkeys (>= 4:5.27.10~),
            kinfocenter (>= 4:5.27.10~),
            kio-extras,
            kmenuedit (>= 4:5.27.10~),
            kscreen (>= 4:5.27.10~),
            ksshaskpass (>= 4:5.27.10~),
            kwin-x11 (>= 4:5.27.10~) | kwin (>= 4:5.27.10~),
            kwrited (>= 4:5.27.10~),
            libpam-kwallet5 (>= 5.27.10~),
            plasma-browser-integration (>= 5.27.10~),
            plasma-discover (>= 5.27.10~),
            plasma-disks (>= 5.27.10~),
            plasma-firewall (>= 5.27.10~),
            plasma-nm (>= 4:5.27.10~),
            plasma-pa (>= 4:5.27.10~),
            plasma-systemmonitor (>= 5.27.10~),
            plasma-thunderbolt (>= 5.27.10~),
            plasma-vault (>= 5.27.10~),
            powerdevil (>= 4:5.27.10~),
            systemsettings (>= 4:5.27.10~),
            xdg-desktop-portal-gtk,
            xdg-desktop-portal-kde (>= 5.27.10~),
Suggests: kde-config-flatpak (>= 4:5.27.10~),
Breaks: baloo-kf5 (<< 5.5),
        kactivities,
        kde-config-touchpad (<< 4:5),
        kde-workspace-bin,
        kde-workspace-data,
        plasma-widget-kimpanel,
        plasma-widgets-addons (<< 4:5.17.5~),
        user-manager (<< 4:5.20),
Replaces: baloo-kf5 (<< 5.5),
          kactivities,
          kde-config-touchpad (<< 4:5),
          kde-workspace-bin,
          kde-workspace-data,
          plasma-widget-kimpanel,
          plasma-widgets-addons (<< 4:5.17.5~),
Description: Tools and widgets for the desktop
 Plasma Desktop offers a beautiful looking desktop
 that takes complete advantage of modern computing technology.
 Through the use of visual effects and scalable graphics,
 the desktop experience is not only smooth but also pleasant
 to the eye. The looks of Plasma Desktop not only provide beauty,
 they are also used to support and improve your computer
 activities effectively, without being distracting.
 .
 This package is part of the KDE Plasma.

Package: plasma-desktop-data
Architecture: all
Depends: python3:any, ${misc:Depends},
Recommends: plasma-framework (>= 4:5.27.10~),
            plasma-workspace (>= 4:5.27.10~),
            qml-module-org-kde-activities,
            qml-module-org-kde-kwindowsystem,
            qml-module-org-kde-newstuff,
            qml-module-qt-labs-platform,
            qml-module-qtquick-dialogs,
Breaks: baloo-kf5 (<< 5.5),
        kactivities,
        kde-config-touchpad (<< 4:5),
        kde-workspace-bin,
        kde-workspace-data,
        kdeplasma-addons-data (<< 4:5.17.5~),
        plasma-widget-kimpanel,
        plasma-widgets-addons (<< 4:5.25.70~),
        ${kde-l10n:all},
Replaces: baloo-kf5 (<< 5.5),
          kactivities,
          kde-config-touchpad (<< 4:5),
          kde-workspace-bin,
          kde-workspace-data,
          kdeplasma-addons-data (<< 4:5.17.5~),
          plasma-widget-kimpanel,
          plasma-widgets-addons (<< 4:5.25.70~),
          ${kde-l10n:all},
Description: Tools and widgets for the desktop data files
 Plasma Desktop offers a beautiful looking desktop
 that takes complete advantage of modern computing technology.
 Through the use of visual effects and scalable graphics,
 the desktop experience is not only smooth but also pleasant
 to the eye. The looks of Plasma Desktop not only provide beauty,
 they are also used to support and improve your computer
 activities effectively, without being distracting.
 .
 This package is part of the KDE Plasma.
 .
 This package contains the data files

Package: plasma-desktop-dev
Section: devel
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         ${so:Depends},
Breaks: kde-config-touchpad (<< 4:5)
Replaces: kde-config-touchpad (<< 4:5)
Description: Tools and widgets for the desktop
 Plasma Desktop offers a beautiful looking desktop
 that takes complete advantage of modern computing technology.
 Through the use of visual effects and scalable graphics,
 the desktop experience is not only smooth but also pleasant
 to the eye. The looks of Plasma Desktop not only provide beauty,
 they are also used to support and improve your computer
 activities effectively, without being distracting.
 .
 This package is part of the KDE Plasma.
